# Distributed Statistical Computing (大数据分布式计算——教学讲义以及案例)

    developed by

    Feng Li
    School of Statistics and Mathematics
    Central University of Finance and Economics
    feng.li@cufe.edu.cn

由中央财经大学统计与数学学院[李丰](https://feng.li/)建设。

## Course Homepage （课程主页）

   [https://feng.li/distcomp/](https://feng.li/distcomp/)

## Books (中文配套教材)

- Distributed Statistical Computing for Big Data and Case Studies (大数据分布式计算与案例) ISBN：9787300230276
    - Available at [JD.COM](https://item.jd.com/11990410.html)

- New version (In Preparation)

    - [HTML format](https://feng.li/files/distcompbook)
    - [Source](https://github.com/feng-li/distcompbook)

## Contents (目录)

### Teaching slides and demo code (with Jupyter Notebook format)

#### Quick View

You could view all the notebooks in this repository via the [Jupyter Notebook Viewer](https://nbviewer.jupyter.org/github/feng-li/Distributed-Statistical-Computing)

#### Run the demo locally
Requirements to run the notebook interactively

- Python (>= 3.6.0)
  - [`findspark`](https://github.com/minrk/findspark) (invoke Spark from Python Session)
  - `numpy`, `scipy`, `pandas`

- Hadoop (>= 2.7.0)
- Hive   (>= 2.3.3)
- Spark  (>= 2.3.1)

- Jupyter Notebook (>= 5.0)

    - [RISE](https://github.com/damianavila/RISE) (for Jupyter slides)

        Use `Alt+R` to enter slideshow mode

    - [Bash Kernel](https://github.com/takluyver/bash_kernel) (for Linux and Hadoop, Hive, Spark batch mode)
    - [IPython kernel for Python 3](https://ipython.readthedocs.io/en/latest/install/kernel_install.html) (for Interactive PySpark Sessions)
    - [HiveQL Kernel](https://github.com/EDS-APHP/HiveQLKernel) (for Interactive Hive Sessions)
    - [Spark Toree](https://toree.apache.org/docs/current/user/quick-start/) (for Interactive Spark Scala Sessions)

### [Distributed Statistical Computing Cases](https://github.com/feng-li/Distributed-Statistical-Computing/tree/master/book-examples) in markdown and tex format  (out dated).
