# 实例分析：分层随机抽样


## 准备知识

* 分层抽样基本知识
* R
* Hadoop Streaming

## 数据生成

本次案例准备用Hadoop程序，实现对随机生成的总体数据进行分层随机抽样，然后计算总体均值的估计
值。总体数据由map函数生成,没有保存到txt文档。

    library(sampling)
    a <- runif(1000, 1, 10)
    b <- rnorm(2000, 2.5, 5)
    c <- rexp(1500, 0.5)
    t <- c(a,b,c)

其中a层为第一层，是一个包含1000个个体的服从（1，10）之间均匀分布的子总体；b层为第二层，是
一个均值为2.5，标准差为5，包含2000个个体的服从正态分布的子总体；c层为第三层，是一个包含
1500个个体的、均值为2的服从指数分布的子总体。


样本量为450，在第一层中抽取100个样本，在第二层中抽取250个样本，在第三层中抽取150个样本。由
于无法在Mapper和Reducer中分开计算标准差，无法使用抽样中变异系数对估计效果进行评价，只在
Mapper中计算总体均值真值和简单随机抽样得到均值的估计值，然后与分层随机抽样得到的估计值做直
观上比较。

## Mapper和Reducer设计

* Mapper的任务是在每层中用简单随机的方式抽取需要的样本量，然后计算样本的均值，最后将均值传
到Reducer中。本部分完整代码见`01-stratified-sampling/xymap.R`文件。

* Reducer的任务是用得到的均值加权平均得到总体均值的估计。本部分完整代码见
`01-stratified-sampling/xyred.R`文件。

## 结果

运行程序后得到分层随机抽样对总体均值的估计值为3.063439。


在Mapper中添加输出真值和简单随机抽样得到的估计值的命令，得到总体均值真值为3.106485，简单随
机抽样估计值为3.008685。


直观上，分层随机抽样的估计精度高于了简单随机抽样，但是只是进行了一次抽样，也没有比较不同样
本量，结果比较随机，需要进行较大的改进。（感谢中国人民大学辛思提供素材和案例。）
